#ifndef _EMU_GENERAL_H_
#define _EMU_GENERAL_H_

void emu_AAA(emu_context *ctx, struct INSTRUCTION *instr);
void emu_AAD(emu_context *ctx, struct INSTRUCTION *instr);
void emu_AAM(emu_context *ctx, struct INSTRUCTION *instr);
void emu_AAS(emu_context *ctx, struct INSTRUCTION *instr);
void emu_DAA(emu_context *ctx, struct INSTRUCTION *instr);
void emu_DAS(emu_context *ctx, struct INSTRUCTION *instr);
void emu_MOV(emu_context *ctx, struct INSTRUCTION *instr);
void emu_LEA(emu_context *ctx, struct INSTRUCTION *instr);
void emu_ADC(emu_context *ctx, struct INSTRUCTION *instr);
void emu_ADD(emu_context *ctx, struct INSTRUCTION *instr);
void emu_SUB(emu_context *ctx, struct INSTRUCTION *instr);
void emu_SBB(emu_context *ctx, struct INSTRUCTION *instr);
void emu_AND(emu_context *ctx, struct INSTRUCTION *instr);
void emu_INC(emu_context *ctx, struct INSTRUCTION *instr);
void emu_DEC(emu_context *ctx, struct INSTRUCTION *instr);
void emu_CLC(emu_context *ctx, struct INSTRUCTION *instr);
void emu_STC(emu_context *ctx, struct INSTRUCTION *instr);
void emu_CLD(emu_context *ctx, struct INSTRUCTION *instr);
void emu_STD(emu_context *ctx, struct INSTRUCTION *instr);
void emu_CLI(emu_context *ctx, struct INSTRUCTION *instr);
void emu_STI(emu_context *ctx, struct INSTRUCTION *instr);
void emu_BSF(emu_context *ctx, struct INSTRUCTION *instr);
void emu_BSR(emu_context *ctx, struct INSTRUCTION *instr);
void emu_BT(emu_context *ctx, struct INSTRUCTION *instr);
void emu_BTC(emu_context *ctx, struct INSTRUCTION *instr);
void emu_BTR(emu_context *ctx, struct INSTRUCTION *instr);
void emu_BTS(emu_context *ctx, struct INSTRUCTION *instr);
void emu_BSWAP(emu_context *ctx, struct INSTRUCTION *instr);
void emu_CBW(emu_context *ctx, struct INSTRUCTION *instr);
void emu_CLTS(emu_context *ctx, struct INSTRUCTION *instr);
void emu_CMC(emu_context *ctx, struct INSTRUCTION *instr);
void emu_CMOVcc(emu_context *ctx, struct INSTRUCTION *instr, int if_ok);
void emu_ARPL(emu_context *ctx, struct INSTRUCTION *instr);
void emu_BOUND(emu_context *ctx, struct INSTRUCTION *instr);
void emu_CMP(emu_context *ctx, struct INSTRUCTION *instr);
void emu_CMPXCHG(emu_context *ctx, struct INSTRUCTION *instr);
void emu_CMPXCHG8B(emu_context *ctx, struct INSTRUCTION *instr);
void emu_CWD(emu_context *ctx, struct INSTRUCTION *instr);
void emu_DIV(emu_context *ctx, struct INSTRUCTION *instr);
void emu_IDIV(emu_context *ctx, struct INSTRUCTION *instr);
void emu_MUL(emu_context *ctx, struct INSTRUCTION *instr);
void emu_IMUL(emu_context *ctx, struct INSTRUCTION *instr);
void emu_PUSH(emu_context *ctx, struct INSTRUCTION *instr);
void emu_PUSHA(emu_context *ctx, struct INSTRUCTION *instr);
void emu_PUSHF(emu_context *ctx, struct INSTRUCTION *instr);
void emu_POP(emu_context *ctx, struct INSTRUCTION *instr);
void emu_POPA(emu_context *ctx, struct INSTRUCTION *instr);
void emu_POPF(emu_context *ctx, struct INSTRUCTION *instr);
void emu_JMP(emu_context *ctx, struct INSTRUCTION *instr);
void emu_JCXZ(emu_context *ctx, struct INSTRUCTION *instr);
void emu_JMPF(emu_context *ctx, struct INSTRUCTION *instr);
void emu_CALL(emu_context *ctx, struct INSTRUCTION *instr);
void emu_CALLF(emu_context *ctx, struct INSTRUCTION *instr);
void emu_SAHF(emu_context *ctx, struct INSTRUCTION *instr);
void emu_LAHF(emu_context *ctx, struct INSTRUCTION *instr);
void emu_SALC(emu_context *ctx, struct INSTRUCTION *instr);
void emu_OR(emu_context *ctx, struct INSTRUCTION *instr);
void emu_NOT(emu_context *ctx, struct INSTRUCTION *instr);
void emu_XOR(emu_context *ctx, struct INSTRUCTION *instr);
void emu_NEG(emu_context *ctx, struct INSTRUCTION *instr);
void emu_ROL(emu_context *ctx, struct INSTRUCTION *instr);
void emu_ROR(emu_context *ctx, struct INSTRUCTION *instr);
void emu_RCL(emu_context *ctx, struct INSTRUCTION *instr);
void emu_RCR(emu_context *ctx, struct INSTRUCTION *instr);
void emu_SAR(emu_context *ctx, struct INSTRUCTION *instr);
void emu_SHL(emu_context *ctx, struct INSTRUCTION *instr);
void emu_SHR(emu_context *ctx, struct INSTRUCTION *instr);
void emu_SHLD(emu_context *ctx, struct INSTRUCTION *instr);
void emu_SHRD(emu_context *ctx, struct INSTRUCTION *instr);
void emu_TEST(emu_context *ctx, struct INSTRUCTION *instr);
void emu_MOVSX(emu_context *ctx, struct INSTRUCTION *instr);
void emu_MOVSXD(emu_context *ctx, struct INSTRUCTION *instr);
void emu_MOVZX(emu_context *ctx, struct INSTRUCTION *instr);
void emu_LODS(emu_context *ctx, struct INSTRUCTION *instr);
void emu_STOS(emu_context *ctx, struct INSTRUCTION *instr);
void emu_MOVS(emu_context *ctx, struct INSTRUCTION *instr);
void emu_SCAS(emu_context *ctx, struct INSTRUCTION *instr);
void emu_CMPS(emu_context *ctx, struct INSTRUCTION *instr);
void emu_RETF(emu_context *ctx, struct INSTRUCTION *instr);
void emu_RETN(emu_context *ctx, struct INSTRUCTION *instr);
void emu_IRET(emu_context *ctx, struct INSTRUCTION *instr);
void emu_ENTER(emu_context *ctx, struct INSTRUCTION *instr);
void emu_LEAVE(emu_context *ctx, struct INSTRUCTION *instr);
void emu_HLT(emu_context *ctx, struct INSTRUCTION *instr);
void emu_RDTSC(emu_context *ctx, struct INSTRUCTION *instr);
void emu_RDTSCP(emu_context *ctx, struct INSTRUCTION *instr);
void emu_UD2(emu_context *ctx, struct INSTRUCTION *instr);
void emu_LOOP(emu_context *ctx, struct INSTRUCTION *instr);
void emu_LOOPZ(emu_context *ctx, struct INSTRUCTION *instr);
void emu_LOOPNZ(emu_context *ctx, struct INSTRUCTION *instr);
void emu_XADD(emu_context *ctx, struct INSTRUCTION *instr);
void emu_XCHG(emu_context *ctx, struct INSTRUCTION *instr);
void emu_MOVBE(emu_context *ctx, struct INSTRUCTION *instr);
void emu_XLAT(emu_context *ctx, struct INSTRUCTION *instr);


#define emu_Jcc(_ctx, _instr, _cond) \
	if (_cond) emu_JMP(_ctx, _instr)

#define emu_SETcc(_ctx, _instr, _cond) \
	emu_save_operand(_ctx, _instr, (_cond) != 0, 0, 0)

#endif